﻿// ******************************************************************************************************
// <copyright file="select.designer.cs" company="Caroso.inc">
//     Copyright (c) Carlos Osorio All rights reserved.
// </copyright>
// ******************************************************************************************************
// The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); 
// you may not use this file except in compliance with the License. You may obtain a copy of the License at 
// http:// www.mozilla.org/MPL/ 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF 
// ANY KIND, either express or implied. See the License for the specificlanguage governing rights and 
// limitations under the License. 
// 
// 
// 
// The Initial Developer of this version of the Original Code is carlos Osorio carosocali@gmail.com
// 
// Contributor(s): (Open source contributors should list themselves and their modifications here). 
// Change Log: 
// Date           Changed By      Notes
// 22 Nov 2010    Carlos Osorio   Test in StyleCop
// ******************************************************************************************************
namespace Velsto
{
    /// <summary>
    /// Definition of basis objects use in Select Class
    /// </summary>
    public partial class Select
    {
        /// <summary>
        /// This combox get the list of layers
        /// </summary>
        private System.Windows.Forms.ComboBox comboBox1;

        /// <summary>
        /// Text 1 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label1;

        /// <summary>
        /// Text 2 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label2;

        /// <summary>
        /// Text 3 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label3;

        /// <summary>
        /// Group of elements in the form select
        /// </summary>
        private System.Windows.Forms.GroupBox groupBox1;

        /// <summary>
        /// List the fields available in the shapefile
        /// </summary>
        private System.Windows.Forms.ComboBox comboBox2;

        /// <summary>
        /// This is the container of the Semivariogram
        /// </summary>
        private System.Windows.Forms.PictureBox pictureBox1;

        /// <summary>
        /// Manage the option to display the semivariogram based on lags
        /// </summary>
        private System.Windows.Forms.RadioButton radioButton2;

        /// <summary>
        /// Manage the option to display all points in the semivariogram
        /// </summary>
        private System.Windows.Forms.RadioButton radioButton1;

        /// <summary>
        /// Action to display the semivariogram
        /// </summary>
        private System.Windows.Forms.Button verSemi;

        /// <summary>
        /// Group elements of the select form
        /// </summary>
        private System.Windows.Forms.GroupBox groupBox2;

        /// <summary>
        /// Text 4 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label8;

        /// <summary>
        /// Textbox to chage the number of lags
        /// </summary>
        private System.Windows.Forms.TextBox txbnLags;

        /// <summary>
        /// Text 5 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label7;

        /// <summary>
        /// Textbox to change the lenght of the lag
        /// </summary>
        private System.Windows.Forms.TextBox txblag;

        /// <summary>
        /// Textbox to change the max distance display in the semivarogram
        /// </summary>
        private System.Windows.Forms.TextBox txbmDist;

        /// <summary>
        /// Text 6 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label6;

        /// <summary>
        /// Text 7 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label4;

        /// <summary>
        /// Textbox to change the max semivariance displayed 
        /// </summary>
        private System.Windows.Forms.TextBox txbmVar;

        /// <summary>
        /// This button applies the changes in the semivariogram graphically
        /// </summary>
        private System.Windows.Forms.Button apply;

        /// <summary>
        /// Group of elements 
        /// </summary>
        private System.Windows.Forms.GroupBox groupBox3;

        /// <summary>
        /// This button applies the changes in the model
        /// </summary>
        private System.Windows.Forms.Button button1;

        /// <summary>
        /// Display the models available
        /// </summary>
        private System.Windows.Forms.ListBox listBox1;

        /// <summary>
        /// Text 8 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label12;

        /// <summary>
        /// Change the value of the Sill (C1)
        /// </summary>
        private System.Windows.Forms.TextBox mtxc1;

        /// <summary>
        /// Text 9 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label11;

        /// <summary>
        /// Change the value of the Nugget
        /// </summary>
        private System.Windows.Forms.TextBox mtxc0;

        /// <summary>
        /// Text 10 uses in the form Select
        /// </summary>
        private System.Windows.Forms.Label label10;

        /// <summary>
        /// Change the value in the Range
        /// </summary>
        private System.Windows.Forms.TextBox mtxrange;

        /// <summary>
        /// Group elements in the Select form
        /// </summary>
        private System.Windows.Forms.GroupBox groupBox4;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }

            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.radioButton2 = new System.Windows.Forms.RadioButton();
            this.radioButton1 = new System.Windows.Forms.RadioButton();
            this.verSemi = new System.Windows.Forms.Button();
            this.comboBox2 = new System.Windows.Forms.ComboBox();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.apply = new System.Windows.Forms.Button();
            this.label8 = new System.Windows.Forms.Label();
            this.txbnLags = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.txblag = new System.Windows.Forms.TextBox();
            this.txbmDist = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.txbmVar = new System.Windows.Forms.TextBox();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.button1 = new System.Windows.Forms.Button();
            this.listBox1 = new System.Windows.Forms.ListBox();
            this.label12 = new System.Windows.Forms.Label();
            this.mtxc1 = new System.Windows.Forms.TextBox();
            this.label11 = new System.Windows.Forms.Label();
            this.mtxc0 = new System.Windows.Forms.TextBox();
            this.label10 = new System.Windows.Forms.Label();
            this.mtxrange = new System.Windows.Forms.TextBox();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.butZ_well = new System.Windows.Forms.Button();
            this.butKrig_resid = new System.Windows.Forms.Button();
            this.butZdev_well = new System.Windows.Forms.Button();
            this.butWell_bull = new System.Windows.Forms.Button();
            this.comboBox3 = new System.Windows.Forms.ComboBox();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.groupBox2.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.SuspendLayout();
            // 
            // comboBox1
            // 
            this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Location = new System.Drawing.Point(129, 22);
            this.comboBox1.Margin = new System.Windows.Forms.Padding(4);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(184, 24);
            this.comboBox1.TabIndex = 0;
            this.comboBox1.Visible = false;
            this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.ComboBox1_SelectedIndexChanged);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(348, 22);
            this.label1.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(503, 17);
            this.label1.TabIndex = 1;
            this.label1.Text = "This tool determines the variogram model for subsequent kriging of residuals.  ";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(17, 34);
            this.label2.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(38, 17);
            this.label2.TabIndex = 2;
            this.label2.Text = "Field";
            this.label2.Visible = false;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(33, 22);
            this.label3.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(87, 17);
            this.label3.TabIndex = 3;
            this.label3.Text = "Select Layer";
            this.label3.Visible = false;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.radioButton2);
            this.groupBox1.Controls.Add(this.radioButton1);
            this.groupBox1.Controls.Add(this.verSemi);
            this.groupBox1.Controls.Add(this.comboBox2);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Enabled = false;
            this.groupBox1.Location = new System.Drawing.Point(37, 55);
            this.groupBox1.Margin = new System.Windows.Forms.Padding(4);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Padding = new System.Windows.Forms.Padding(4);
            this.groupBox1.Size = new System.Drawing.Size(973, 85);
            this.groupBox1.TabIndex = 4;
            this.groupBox1.TabStop = false;
            // 
            // radioButton2
            // 
            this.radioButton2.AutoSize = true;
            this.radioButton2.Checked = true;
            this.radioButton2.Location = new System.Drawing.Point(679, 34);
            this.radioButton2.Margin = new System.Windows.Forms.Padding(4);
            this.radioButton2.Name = "radioButton2";
            this.radioButton2.Size = new System.Drawing.Size(150, 21);
            this.radioButton2.TabIndex = 5;
            this.radioButton2.TabStop = true;
            this.radioButton2.Text = "By invervals (Lags)";
            this.radioButton2.UseVisualStyleBackColor = true;
            // 
            // radioButton1
            // 
            this.radioButton1.AutoSize = true;
            this.radioButton1.Location = new System.Drawing.Point(517, 32);
            this.radioButton1.Margin = new System.Windows.Forms.Padding(4);
            this.radioButton1.Name = "radioButton1";
            this.radioButton1.Size = new System.Drawing.Size(108, 21);
            this.radioButton1.TabIndex = 4;
            this.radioButton1.Text = "All distances";
            this.radioButton1.UseVisualStyleBackColor = true;
            // 
            // verSemi
            // 
            this.verSemi.Location = new System.Drawing.Point(261, 28);
            this.verSemi.Margin = new System.Windows.Forms.Padding(4);
            this.verSemi.Name = "verSemi";
            this.verSemi.Size = new System.Drawing.Size(215, 27);
            this.verSemi.TabIndex = 3;
            this.verSemi.Text = "Show expertimental variogram";
            this.verSemi.UseVisualStyleBackColor = true;
            this.verSemi.Click += new System.EventHandler(this.VerSemi_Click);
            // 
            // comboBox2
            // 
            this.comboBox2.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox2.FormattingEnabled = true;
            this.comboBox2.Location = new System.Drawing.Point(0, 0);
            this.comboBox2.Margin = new System.Windows.Forms.Padding(4);
            this.comboBox2.Name = "comboBox2";
            this.comboBox2.Size = new System.Drawing.Size(187, 24);
            this.comboBox2.TabIndex = 0;
            this.comboBox2.Visible = false;
            this.comboBox2.SelectedIndexChanged += new System.EventHandler(this.ComboBox2_SelectedIndexChanged);
            // 
            // pictureBox1
            // 
            this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pictureBox1.Location = new System.Drawing.Point(37, 148);
            this.pictureBox1.Margin = new System.Windows.Forms.Padding(4);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(733, 246);
            this.pictureBox1.TabIndex = 6;
            this.pictureBox1.TabStop = false;
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.apply);
            this.groupBox2.Controls.Add(this.label8);
            this.groupBox2.Controls.Add(this.txbnLags);
            this.groupBox2.Controls.Add(this.butWell_bull);
            this.groupBox2.Controls.Add(this.label7);
            this.groupBox2.Controls.Add(this.txblag);
            this.groupBox2.Controls.Add(this.txbmDist);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Controls.Add(this.txbmVar);
            this.groupBox2.Enabled = false;
            this.groupBox2.Location = new System.Drawing.Point(779, 140);
            this.groupBox2.Margin = new System.Windows.Forms.Padding(4);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Padding = new System.Windows.Forms.Padding(4);
            this.groupBox2.Size = new System.Drawing.Size(232, 254);
            this.groupBox2.TabIndex = 7;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Graph Options ";
            // 
            // apply
            // 
            this.apply.Location = new System.Drawing.Point(121, 177);
            this.apply.Margin = new System.Windows.Forms.Padding(4);
            this.apply.Name = "apply";
            this.apply.Size = new System.Drawing.Size(89, 26);
            this.apply.TabIndex = 8;
            this.apply.Text = "Apply";
            this.apply.UseVisualStyleBackColor = true;
            this.apply.Click += new System.EventHandler(this.Apply_Click);
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(15, 149);
            this.label8.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(109, 17);
            this.label8.TabIndex = 7;
            this.label8.Text = "Number of Lags";
            // 
            // txbnLags
            // 
            this.txbnLags.Location = new System.Drawing.Point(144, 145);
            this.txbnLags.Margin = new System.Windows.Forms.Padding(4);
            this.txbnLags.Name = "txbnLags";
            this.txbnLags.Size = new System.Drawing.Size(65, 22);
            this.txbnLags.TabIndex = 6;
            this.txbnLags.TextChanged += new System.EventHandler(this.Txb_nLags_TextChanged);
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(15, 122);
            this.label7.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(32, 17);
            this.label7.TabIndex = 5;
            this.label7.Text = "Lag";
            // 
            // txblag
            // 
            this.txblag.Location = new System.Drawing.Point(144, 118);
            this.txblag.Margin = new System.Windows.Forms.Padding(4);
            this.txblag.Name = "txblag";
            this.txblag.Size = new System.Drawing.Size(65, 22);
            this.txblag.TabIndex = 4;
            this.txblag.TextChanged += new System.EventHandler(this.Txb_lag_TextChanged);
            // 
            // txbmDist
            // 
            this.txbmDist.Location = new System.Drawing.Point(144, 90);
            this.txbmDist.Margin = new System.Windows.Forms.Padding(4);
            this.txbmDist.Name = "txbmDist";
            this.txbmDist.Size = new System.Drawing.Size(65, 22);
            this.txbmDist.TabIndex = 3;
            this.txbmDist.TextChanged += new System.EventHandler(this.Txb_mDist_TextChanged);
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(15, 94);
            this.label6.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(96, 17);
            this.label6.TabIndex = 2;
            this.label6.Text = "Max. Distance";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(15, 66);
            this.label4.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(97, 17);
            this.label4.TabIndex = 1;
            this.label4.Text = "Max. Variance";
            // 
            // txbmVar
            // 
            this.txbmVar.Location = new System.Drawing.Point(144, 63);
            this.txbmVar.Margin = new System.Windows.Forms.Padding(4);
            this.txbmVar.Name = "txbmVar";
            this.txbmVar.Size = new System.Drawing.Size(65, 22);
            this.txbmVar.TabIndex = 0;
            this.txbmVar.TextChanged += new System.EventHandler(this.Txb_mVar_TextChanged);
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.button1);
            this.groupBox3.Controls.Add(this.listBox1);
            this.groupBox3.Controls.Add(this.label12);
            this.groupBox3.Controls.Add(this.mtxc1);
            this.groupBox3.Controls.Add(this.label11);
            this.groupBox3.Controls.Add(this.mtxc0);
            this.groupBox3.Controls.Add(this.label10);
            this.groupBox3.Controls.Add(this.mtxrange);
            this.groupBox3.Enabled = false;
            this.groupBox3.Location = new System.Drawing.Point(37, 401);
            this.groupBox3.Margin = new System.Windows.Forms.Padding(4);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Padding = new System.Windows.Forms.Padding(4);
            this.groupBox3.Size = new System.Drawing.Size(476, 124);
            this.groupBox3.TabIndex = 8;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "Models";
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(357, 28);
            this.button1.Margin = new System.Windows.Forms.Padding(4);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(97, 28);
            this.button1.TabIndex = 16;
            this.button1.Text = "Show model";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.Button1_Click);
            // 
            // listBox1
            // 
            this.listBox1.FormattingEnabled = true;
            this.listBox1.ItemHeight = 16;
            this.listBox1.Items.AddRange(new object[] {
            "Exponential",
            "Gaussian",
            "Spherical"});
            this.listBox1.Location = new System.Drawing.Point(17, 23);
            this.listBox1.Margin = new System.Windows.Forms.Padding(4);
            this.listBox1.Name = "listBox1";
            this.listBox1.Size = new System.Drawing.Size(165, 84);
            this.listBox1.TabIndex = 15;
            this.listBox1.SelectedIndexChanged += new System.EventHandler(this.ListBox1_SelectedIndexChanged);
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(201, 89);
            this.label12.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(26, 17);
            this.label12.TabIndex = 14;
            this.label12.Text = "Sill";
            // 
            // mtxc1
            // 
            this.mtxc1.Location = new System.Drawing.Point(261, 85);
            this.mtxc1.Margin = new System.Windows.Forms.Padding(4);
            this.mtxc1.Name = "mtxc1";
            this.mtxc1.Size = new System.Drawing.Size(65, 22);
            this.mtxc1.TabIndex = 13;
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(201, 60);
            this.label11.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(54, 17);
            this.label11.TabIndex = 12;
            this.label11.Text = "Nugget";
            // 
            // mtxc0
            // 
            this.mtxc0.Location = new System.Drawing.Point(261, 57);
            this.mtxc0.Margin = new System.Windows.Forms.Padding(4);
            this.mtxc0.Name = "mtxc0";
            this.mtxc0.Size = new System.Drawing.Size(65, 22);
            this.mtxc0.TabIndex = 11;
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(201, 28);
            this.label10.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(50, 17);
            this.label10.TabIndex = 10;
            this.label10.Text = "Range";
            // 
            // mtxrange
            // 
            this.mtxrange.Location = new System.Drawing.Point(261, 25);
            this.mtxrange.Margin = new System.Windows.Forms.Padding(4);
            this.mtxrange.Name = "mtxrange";
            this.mtxrange.Size = new System.Drawing.Size(65, 22);
            this.mtxrange.TabIndex = 9;
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.comboBox3);
            this.groupBox4.Controls.Add(this.butZ_well);
            this.groupBox4.Controls.Add(this.butKrig_resid);
            this.groupBox4.Controls.Add(this.butZdev_well);
            this.groupBox4.Enabled = false;
            this.groupBox4.Location = new System.Drawing.Point(521, 401);
            this.groupBox4.Margin = new System.Windows.Forms.Padding(4);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Padding = new System.Windows.Forms.Padding(4);
            this.groupBox4.Size = new System.Drawing.Size(489, 124);
            this.groupBox4.TabIndex = 9;
            this.groupBox4.TabStop = false;
            // 
            // butZ_well
            // 
            this.butZ_well.Location = new System.Drawing.Point(276, 43);
            this.butZ_well.Name = "butZ_well";
            this.butZ_well.Size = new System.Drawing.Size(92, 48);
            this.butZ_well.TabIndex = 3;
            this.butZ_well.Text = "Well tied depth map";
            this.butZ_well.UseVisualStyleBackColor = true;
            this.butZ_well.Click += new System.EventHandler(this.butZ_well_Click);
            // 
            // butKrig_resid
            // 
            this.butKrig_resid.Location = new System.Drawing.Point(175, 43);
            this.butKrig_resid.Name = "butKrig_resid";
            this.butKrig_resid.Size = new System.Drawing.Size(86, 51);
            this.butKrig_resid.TabIndex = 2;
            this.butKrig_resid.Text = "Kriged residuals.";
            this.butKrig_resid.UseVisualStyleBackColor = true;
            this.butKrig_resid.Click += new System.EventHandler(this.butKrig_resid_Click);
            // 
            // butZdev_well
            // 
            this.butZdev_well.Location = new System.Drawing.Point(379, 42);
            this.butZdev_well.Name = "butZdev_well";
            this.butZdev_well.Size = new System.Drawing.Size(98, 48);
            this.butZdev_well.TabIndex = 1;
            this.butZdev_well.Text = "Well calibr Uncert map";
            this.butZdev_well.UseVisualStyleBackColor = true;
            this.butZdev_well.Click += new System.EventHandler(this.butZdev_well_Click);
            // 
            // butWell_bull
            // 
            this.butWell_bull.Location = new System.Drawing.Point(7, 204);
            this.butWell_bull.Name = "butWell_bull";
            this.butWell_bull.Size = new System.Drawing.Size(73, 50);
            this.butWell_bull.TabIndex = 0;
            this.butWell_bull.Text = "Well bullets";
            this.butWell_bull.UseVisualStyleBackColor = true;
            this.butWell_bull.Visible = false;
            this.butWell_bull.Click += new System.EventHandler(this.butWell_bull_Click);
            // 
            // comboBox3
            // 
            this.comboBox3.FormattingEnabled = true;
            this.comboBox3.Location = new System.Drawing.Point(7, 53);
            this.comboBox3.Name = "comboBox3";
            this.comboBox3.Size = new System.Drawing.Size(154, 24);
            this.comboBox3.TabIndex = 4;
            this.comboBox3.Text = "Kriging type";
            this.comboBox3.SelectedIndexChanged += new System.EventHandler(this.comboBox3_SelectedIndexChanged);
            // 
            // Select
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(8F, 16F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(1027, 538);
            this.Controls.Add(this.groupBox4);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.pictureBox1);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.comboBox1);
            this.Margin = new System.Windows.Forms.Padding(4);
            this.Name = "Select";
            this.Text = "Variogram Models";
            this.Load += new System.EventHandler(this.Select_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBox3.ResumeLayout(false);
            this.groupBox3.PerformLayout();
            this.groupBox4.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion

        private System.Windows.Forms.Button butWell_bull;
        private System.Windows.Forms.Button butKrig_resid;
        private System.Windows.Forms.Button butZdev_well;
        private System.Windows.Forms.Button butZ_well;
        private System.Windows.Forms.ComboBox comboBox3;
    }
}