﻿/*
 * Application  : Velsto
 * Class        : LayerparamsEntity
 * 04/06/2010-  : M.A.van Ravesteijn (Raafcom)
 *   02/09/2010   Initial version v1.0
 * 
 * Class for Layer Parameter Entity to maintain parameters(e.g.Velocity parameters)
 * per Layer.
 */ 
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Velsto
{
    public class LayerparamsEntity
    {
        private int v0vintOption = 0;
        private int v0vint = 0;
        private int v0vintDev = 0;
        private double k = 0.0;
        private double kDev = 0.0;
        private double f = 1.0;
        private int depV0K = 0;
        private double twtDev = 0.0;
        private int depVel = 0;

        public LayerparamsEntity()
        {
        }

        public int V0vintOption 
        {
            get { return v0vintOption; }
            set { v0vintOption = value; }
        }
        
        public int V0vint 
        {
            get { return v0vint; }
            set { v0vint = value; }
        }

        public int V0vintDev
        {
            get { return v0vintDev; }
            set { v0vintDev = value; }
        }
        
        public double K
        {
            get { return k; }
            set { k = value; }
        }
        
        public double KDev
        {
            get { return kDev; }
            set { kDev = value; }
        }
        
        public double F
        {
            get { return f; }
            set { f = value; }
        }

        public int DepV0K
        {
            get { return depV0K; }
            set { depV0K = value; }
        }
        
        public double TwtDev
        {
            get { return twtDev; }
            set { twtDev = value; }
        }
        
        public int DepVel
        {
            get { return depVel; }
            set { depVel = value; }
        }

    }
}
